# MySQL-Front Dump 1.16 beta
#
# Host: localhost Database: editor
#--------------------------------------------------------
# Server version 3.23.32
#
# Table structure for table 'antrieb'
#

CREATE TABLE antrieb (
  aid smallint(5) unsigned NOT NULL auto_increment,
  name varchar(32) ,
  gewicht int(10) ,
  PRIMARY KEY (aid)
);


#
# Table structure for table 'durchsichtigkeit'
#

CREATE TABLE durchsichtigkeit (
  sid smallint(6) NOT NULL DEFAULT '0' ,
  gid smallint(6) NOT NULL DEFAULT '0' ,
  scandauer smallint(6) ,
  durchsichtigkeit varchar(5) ,
  PRIMARY KEY (gid,sid)
);


#
# Table structure for table 'gelaende'
#

CREATE TABLE gelaende (
  gid smallint(5) unsigned NOT NULL auto_increment,
  name varchar(32) ,
  bild varchar(150) ,
  hoehe smallint(6) ,
  festigkeit smallint(6) ,
  feuchtigkeit smallint(6) ,
  oberflaeche smallint(6) ,
  laenge smallint(6) ,
  breite smallint(6) ,
  PRIMARY KEY (gid)
);


#
# Table structure for table 'kachel'
#

CREATE TABLE kachel (
  spid smallint(6) NOT NULL DEFAULT '0' ,
  mid smallint(6) ,
  gid smallint(6) ,
  hoehe smallint(6) ,
  x smallint(6) NOT NULL DEFAULT '0' ,
  y smallint(6) NOT NULL DEFAULT '0' ,
  PRIMARY KEY (spid,x,y)
);


#
# Table structure for table 'mine'
#

CREATE TABLE mine (
  mid smallint(5) unsigned NOT NULL auto_increment,
  name varchar(32) ,
  bild varchar(150) ,
  PRIMARY KEY (mid)
);


#
# Table structure for table 'passierbarkeit'
#

CREATE TABLE passierbarkeit (
  aid smallint(6) NOT NULL DEFAULT '0' ,
  gid smallint(6) NOT NULL DEFAULT '0' ,
  geschwindigkeit smallint(10) ,
  energieverbrauch smallint(10) ,
  passierbarkeit varchar(5) ,
  PRIMARY KEY (gid,aid)
);


#
# Table structure for table 'roboter'
#

CREATE TABLE roboter (
  rid smallint(5) unsigned NOT NULL auto_increment,
  aid smallint(6) ,
  sendereichweite int(10) ,
  name varchar(32) ,
  energievorrat int(10) ,
  laenge smallint(6) ,
  breite smallint(6) ,
  gewicht int(10) ,
  bild varchar(150) ,
  PRIMARY KEY (rid)
);


#
# Table structure for table 'rszuordnung'
#

CREATE TABLE rszuordnung (
  rid smallint(6) NOT NULL DEFAULT '0' ,
  sid smallint(6) NOT NULL DEFAULT '0' ,
  PRIMARY KEY (rid,sid)
);


#
# Table structure for table 'schablonenkachel'
#

CREATE TABLE schablonenkachel (
  skid smallint(5) unsigned NOT NULL auto_increment,
  sid smallint(6) NOT NULL DEFAULT '0' ,
  x smallint(6) ,
  y smallint(6) ,
  sichtbereich smallint(6) ,
  PRIMARY KEY (skid,sid)
);


#
# Table structure for table 'sensor'
#

CREATE TABLE sensor (
  sid smallint(5) unsigned NOT NULL auto_increment,
  name varchar(32) ,
  gewicht int(10) ,
  grundenergie int(10) ,
  scanenergie int(10) ,
  anzahlebenen int(10) ,
  PRIMARY KEY (sid)
);


#
# Table structure for table 'sensormeldung'
#

CREATE TABLE sensormeldung (
  sid smallint(6) NOT NULL DEFAULT '0' ,
  gid smallint(6) NOT NULL DEFAULT '0' ,
  mid smallint(6) NOT NULL DEFAULT '0' ,
  sensorebene smallint(6) NOT NULL DEFAULT '0' ,
  meldung varchar(150) ,
  PRIMARY KEY (mid,gid,sid,sensorebene)
);


#
# Table structure for table 'spielfeld'
#

CREATE TABLE spielfeld (
  spid smallint(5) unsigned NOT NULL auto_increment,
  name varchar(32) ,
  laenge smallint(6) ,
  breite smallint(6) ,
  uid smallint(6) NOT NULL DEFAULT '0' ,
  PRIMARY KEY (spid)
);


#
# Table structure for table 'umgantriebz'
#

CREATE TABLE umgantriebz (
  uid smallint(6) NOT NULL DEFAULT '0' ,
  aid smallint(6) NOT NULL DEFAULT '0' ,
  PRIMARY KEY (uid,aid)
);


#
# Table structure for table 'umgebung'
#

CREATE TABLE umgebung (
  uid smallint(5) unsigned NOT NULL auto_increment,
  uname varchar(32) ,
  aktiv varchar(5) ,
  PRIMARY KEY (uid)
);


#
# Table structure for table 'umggelaendez'
#

CREATE TABLE umggelaendez (
  uid smallint(6) NOT NULL DEFAULT '0' ,
  gid smallint(6) NOT NULL DEFAULT '0' ,
  PRIMARY KEY (uid,gid)
);


#
# Table structure for table 'umgminez'
#

CREATE TABLE umgminez (
  uid smallint(6) NOT NULL DEFAULT '0' ,
  mid smallint(6) NOT NULL DEFAULT '0' ,
  PRIMARY KEY (uid,mid)
);


#
# Table structure for table 'umgroboterz'
#

CREATE TABLE umgroboterz (
  uid smallint(6) NOT NULL DEFAULT '0' ,
  rid smallint(6) NOT NULL DEFAULT '0' ,
  PRIMARY KEY (uid,rid)
);


#
# Table structure for table 'umgsensorz'
#

CREATE TABLE umgsensorz (
  uid smallint(6) NOT NULL DEFAULT '0' ,
  sid smallint(6) NOT NULL DEFAULT '0' ,
  PRIMARY KEY (uid,sid)
);


