package Test;

import java.util.ArrayList;
import java.awt.*;

/**
 *
 * User: hf
 * Date: 21.09.2003
 * Time: 14:55:39
 */
public class TestServer {

    private ArrayList agents = new ArrayList();
    private SimulationWindow sim;

    public TestServer(){

    }

    public void setSim(SimulationWindow sim) {
        this.sim = sim;
    }

    public void startSimulation(){
        sim.update();
        for (int i = 0; i < agents.size(); i++){
            AgentEntry entry = (AgentEntry) agents.get(i);
            entry.getAgent().start();

        }

    }

    public void registerAgent(TestAgent a){
        agents.add(a.getId(), new AgentEntry(a));
    }

    public void unregisterAllAgents(){
        agents = new ArrayList();
    }

    public synchronized void receiveMoveOrder(int id, int moveorder){
        if (moveorder == TestAgent.NO_MOVE){
            System.out.println("Agent Nr. "+id+ "   hat seine Position nicht verndert");
        }
        else{
            AgentEntry entry = (AgentEntry) agents.get(id);
            System.out.print("Agent Nr. "+id+"   Aktuelle Position: X:" + entry.getX() + " Y:"+ entry.getY());
            switch (moveorder){
                case TestAgent.MOVE_NORTH:
                    {
                        int y_old = entry.getY();
                        entry.setY(y_old - 10);
                        System.out.println("   Neue Position: X:" + entry.getX() + " Y:"+ entry.getY());
                        sim.update();
                        break;
                    }
                case TestAgent.MOVE_WEST:
                    {
                        int x_old = entry.getX();
                        entry.setX(x_old -10);
                        System.out.println("   Neue Position: X:" + entry.getX() + " Y:"+ entry.getY());
                        sim.update();
                        break;
                    }
                case TestAgent.MOVE_SOUTH:
                    {
                        int y_old = entry.getY();
                        entry.setY(y_old + 10);
                        System.out.println("   Neue Position: X:" + entry.getX() + " Y:"+ entry.getY());
                        sim.update();
                        break;
                    }
                case TestAgent.MOVE_EAST:
                    {
                        int x_old = entry.getX();
                        entry.setX(x_old + 10);
                        System.out.println("   Neue Position: X:" + entry.getX() + " Y:"+ entry.getY());
                        sim.update();
                        break;
                    }


            } // Ende Switch

        }

    }

    public synchronized int[][] getAgentPositions(){
        int[][] positions = new int[agents.size()][2];
        for (int i = 0; i< agents.size(); i++){
            AgentEntry entry = (AgentEntry) agents.get(i);
            positions[i][0] = entry.getX();
            positions[i][1] = entry.getY();
        }

        return positions;
    }



    class AgentEntry {

        private TestAgent agent;
        int x;
        int y;


        public AgentEntry(TestAgent a){
            this.agent = a;
            x = a.getId()*20 + 100;
            y =  40;
        }

        public int getX() {
            return x;
        }

        public int getY() {
            return y;
        }

        public void setX(int x) {
            this.x = x;
        }

        public void setY(int y) {
            this.y = y;
        }

        public TestAgent getAgent() {
            return agent;
        }



    }

}
