package agent.impl;

import agent.Agent;
import agent.util.MediaHelper;
import agent.agentgui.SimpleAgentRemoteControl;

import java.awt.*;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

import mailbox.Message;
import mailbox.ScanResult;

/**
 * Ferngesteuerter Agent, der von der in agent.agentgui.SimpleAgentRemoteControl
 * implementierten Fernsteuerung gesteuert wird. Die einzige Aufgabe der run()-
 * Schleife ist die Auflsung der erhaltenen Scan-Ergebnisse. Die Verarbeitung
 * wird aus der Schleife heraus in die Methode resolveImages() ausgelagert,die
 * einen eigenen Thread startet und die Ergebnisse in der GUI setzt.
 *
 * User: Standard
 * Date: 07.11.2003
 * Time: 21:20:20
 *
 */
public class RemoteControlledAgent extends Agent {

    protected  MediaHelper ivMediaHelper = new MediaHelper();
    protected final String DEFAULTIMAGE = "C:/Dokumente und Einstellungen/Standard/Desktop/Seminar Minen und Agenten/Seminar_Agenten/src/images/simple_notvisible.gif";
    protected final String ROBOTIMAGE = "C:/Dokumente und Einstellungen/Standard/Desktop/Seminar Minen und Agenten/Seminar_Agenten/src/images/R2D2.gif";
    protected SimpleAgentRemoteControl ivRemoteControl;


    public void run(){

        while(ivRunning){
            try {
                Thread.sleep(500);

                try {
                     Message m = getNextMessage();
                    System.out.println(m.getAbsender() + "  " + m.getBetreff());

                   if (m.getBetreff() == Message.SCANRESULT){
                       resolveImages(m);


                    } else if (m.getBetreff() == Message.REMAININGENERGY){
                        ((SimpleAgentRemoteControl) ivMyDialog).setEnergy((String) m.getContent());

                    }  else {
                        System.out.println("Message erhalten: Absender: " + m.getAbsender() +" - Betreff: "+ m.getBetreff());
                    }  // ende if!!

                } catch (Exception e) {

                }



            } catch (InterruptedException e1) {
                e1.printStackTrace();  //To change body of catch statement use Options | File Templates.
            }

        }}


    public boolean needsDialog() {
        return true;

    }



    public Frame getFrame() {
        if (ivRemoteControl == null){
            ivRemoteControl = new SimpleAgentRemoteControl();
            ivRemoteControl.setAgent(this);
        }
        return ivRemoteControl;
    }


    protected void resolveImages(Message msg){
        // Die Nachricht mu in eine Konstante umgewandelt werden, damit sie von
        // anonym gestarteten inneren Klasse aus benutzbar ist
        final Message m = msg;
        System.out.println(m.getAbsender() + "  " + m.getBetreff());

        if (m.getBetreff() == Message.SCANRESULT){

            new Thread(){
                public void run(){

                    ScanResult res = (ScanResult ) m.getContent();
                    String[][] lvScannedUrls = res.getIvScanresult();
                    Image[][] lvResolvedImages = new Image[lvScannedUrls.length][lvScannedUrls.length];

                    for (int i = 0; i < lvScannedUrls.length; i++){
                        for (int j = 0; j < lvScannedUrls[i].length; j++){
                            // Entscheiden, welches Bild geholt wird

                            if (i == 10 && j == 10){
                                lvResolvedImages[i][j] = ivMediaHelper.getImage(ROBOTIMAGE);
                            } else if (lvScannedUrls[i][j] == null){
                                lvResolvedImages[i][j] = ivMediaHelper.getImage(DEFAULTIMAGE);
                            } else if (lvScannedUrls[i][j].equals(ScanResult.OUTOFSPIELFELD)){
                                lvResolvedImages[i][j] = ivMediaHelper.getImage(DEFAULTIMAGE);
                            } else {
                                lvResolvedImages[i][j] = ivMediaHelper.getImage(lvScannedUrls[i][j]);
                            }
                        }
                    }
                    ivRemoteControl.setScanResult(lvResolvedImages);
                }}.start();


        }  }




}
