package agent.util;

import java.util.Hashtable;
import java.awt.*;

/**
 *
 * Utility-Klasse fr die Auflsung von URLs in entsprechende Objekte
 * und vorhalten bereits geladener inn einem Array.
 *
 * User: Standard
 * Date: 08.11.2003
 * Time: 04:22:53
 *
 */
public class MediaHelper {

    private Hashtable h;

    public MediaHelper(){
        h = new Hashtable();
    }




    /**
     * Diese Methode dient dazu, bergebene URLs aufzulsen, die Medien zu laden
     * und gecached vorzuhalten. Derzeit nicht benutzt, soll spter ausschlielich verwendet
     * werden, falls unterschiedliche Medientypen zum Einsatz kommen.
     * @param url
     */
    public void initializeMedium(String url){

        String filetype = this.getFileSuffix(url);
        if (filetype != null){
            // je nach medientyp einzeln
            if(filetype.equals("gif") || filetype.equals("jpeg") || filetype.equals("jpg")){
                Image m = Toolkit.getDefaultToolkit().getImage(url);
                // unter der vollstndigen URL (wg. der Eindeutigkeit) wird das Bild im Hashtable abgelegt
                h.put(url, m);
            } else {
                log("unbekannter Medientyp");
            }
        }

    }

    /**
     * Diese Methode dient dazu, fr Bilder bergebene URLs aufzulsen, die Medien zu laden
     * und gecached vorzuhalten.
     * @param url
     * @return  Das Image oder null, falls es sich nicht um einen akzeptierten Imagetypen handelt
     */
    public synchronized Image getImage(String url){
        Image ret = null;
        String filetype = this.getFileSuffix(url);
        if (filetype != null){
            // je nach medientyp einzeln
            if (h.containsKey(url)){
                ret = (Image) h.get(url);
            } else if(filetype.equalsIgnoreCase("gif")
                    || filetype.equalsIgnoreCase("jpeg")
                    || filetype.equalsIgnoreCase("jpg")
                    || filetype.equalsIgnoreCase("bmp")){

                Image m = Toolkit.getDefaultToolkit().getImage(url);
                // unter der vollstndigen URL (wg. der Eindeutigkeit) wird das Bild im Hashtable abgelegt
                h.put(url, m);
                ret = m;
            } else {
                log("unbekannter Medientyp");
            }
        }
        return ret;
    }




    // Dient dazu, aus einer URL das Datei-Suffix zu extrahieren
    private String getFileSuffix(String fileName){
        int pointIndex = fileName.lastIndexOf(".");
        String ret = null;
        if (pointIndex > 0){
            ret = fileName.substring(pointIndex + 1);
        }

        return ret;

    }

    private void log(String message){
        System.out.println(this.getClass().toString() + " -> " + message);

    }


}
